<script lang="ts">
	import { entityStore } from "../utils/entityStore";

	import CardButton from '../ui/CardButton.svelte';

	import { HostingType, type HostingTypeLiteral } from '../types';

	export let value: string;

	let serverIsUnderpowered: boolean;

	let setValue = function (newValue: HostingTypeLiteral): void {
		value = newValue;
		$entityStore.hostingType = newValue;
	};

	$: if (value === HostingType.BYOS) {
		serverIsUnderpowered = false;
	}
</script>

<div class="row mb-3">
	<div class="col-md-6 mb-2">
		<CardButton
			heading="Hosting (VPS server provided by us)"
			multipleSelect={false}
			active={value === HostingType.Turnkey}
			faded={value !== null && value != HostingType.Turnkey}
			on:activated={() => setValue(HostingType.Turnkey)}
		>
			<div slot="card-body-content">
				<div class="d-flex flex-row">
					<img src="/img/logos/turnkey_logo.webp" class="server-logo mr-3" alt="turnkey logo" />
					<div class="d-inline-block ms-3">
						<p class="mb-1">
							Use a Hetzner Cloud VPS server
							<strong>managed by us</strong>.
							<br />
							See regions/sizes below.
						</p>

						<p class="mb-0">
							No setup required on your part. <code class="fw-bold">root</code> access available to you.
						</p>
					</div>
				</div>
			</div>

			<div slot="after-card-body">
				<div class="card-footer text-center bg-transparent text-success">
					<strong>
						Guarantees an easier setup and only one provider to deal with (us).
					</strong>
				</div>
			</div>
		</CardButton>
	</div>

	<div class="col-md-6 mb-2">
		<CardButton
			heading="On-Premises (Your Own Server)"
			multipleSelect={false}
			active={value === HostingType.BYOS}
			faded={value !== null && value != HostingType.BYOS}
			on:activated={() => setValue(HostingType.BYOS)}
		>
			<div slot="card-body-content">
				<div class="d-flex flex-row">
					<img src="/img/logos/byos_logo.webp" class="server-logo mr-3" alt="bring your own server logo" />
					<div class="d-inline-block ms-3">
						<p class="mb-1">
							Use any <code>amd64</code> server with a Debian-based distribution (we recommend the latest Ubuntu LTS) that you've <strong>obtained separately</strong>.
						</p>

						<p class="mb-0">
							You'll need to set up SSH access for us.
						</p>
					</div>
				</div>
			</div>

			<div slot="after-card-body">
				<div class="card-footer text-center bg-transparent text-warning">
					<strong>
						Allows more independence and hosting provider (region) flexibility.
					</strong>
				</div>
			</div>
		</CardButton>
	</div>
</div>